import java.net.*;
import java.io.*;
import java.util.*;

/**
 * @author	Carlos Silva Ltty
 * @version 0.1_Beta 30/10/2005
 * 
 * Clase que maneja la conexin de cada cliente
 */

public class ChatHandler extends Thread {
    
    protected static Vector handlers = new Vector();
    protected Socket s;
    protected DataInputStream i;
    protected DataOutputStream o;
    protected String user;
    Vector y = new Vector();
    
/**
 * Constructor de la clase.
 * 
 * @param	s	Socket del cliente.
 * @param	user	nombre de usuario.
 * @param	x	vector que contiene el nombre se los dems usuarios.
 */
    
    public ChatHandler(Socket s, String user, Vector x) throws IOException {
        this.s = s;
        i = new DataInputStream(new BufferedInputStream(s.getInputStream()));
        o = new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
        y = x;
        this.user = user;
    }
/**
 * Escucha por nuevos mensajes y por entrada y salida de otros usuarios.
 */    
    public void run() {
        String Listado="";
        try {
            Enumeration elementos = y.elements();
            while(elementos.hasMoreElements())
                Listado = Listado + (String) elementos.nextElement() + "\n";
            handlers.addElement(this);
            broadcast("->" + Listado);
            while(true) {
                try {
                    String msg = i.readUTF();
                    broadcast(msg);
                } catch (EOFException eof) {
                    y.remove(user);
                    Listado="";
                    elementos = y.elements();
                    while(elementos.hasMoreElements())
                        Listado = Listado + (String) elementos.nextElement() + "\n";
                    broadcast("<-" + Listado);
                } catch (java.net.SocketException soe) {
                    y.remove(user);
                    Listado="";
                    elementos = y.elements();
                    while(elementos.hasMoreElements())
                        Listado = Listado + (String) elementos.nextElement() + "\n";
                    broadcast("<-" + Listado);
                }
            }
        } catch(IOException ex) {
            ex.printStackTrace();
        }
    }
   
/**
 * Mtodo que permite enviar un mismo mensaje a todos los usuarios conectados al servidor.
 * 
 * @param	message	Mensaje a enviar.
*/
    
    protected static void broadcast(String message) {
        synchronized(handlers) {
            Enumeration e = handlers.elements();
            while (e.hasMoreElements()) {
                ChatHandler c = (ChatHandler) e.nextElement();
                try {
                    synchronized(c.o) {
                        c.o.writeUTF(message);
                    }
                    c.o.flush();
                } catch(IOException ex) {
                    c.stop();
                }
            }
        }
    }
}
