import java.net.*;
import java.io.*;
import java.util.*;

/**
 * @author	Carlos Silva Ltty
 * @version 0.1_Beta 30/10/2005
 * 
 * Clase que crea un servidor de Chat con:<br>
 * puerto escucha en 12468 por defecto.<br>
 * sirve en host local (127.0.0.1) por defecto.<br>
 * <br>Para esto utiliza la clase ChatHandler
 */
        

public class  ChatServer {
/**
 * Constructor de la clase.<br>
 * Acepta conexiones de los clientes.<br>
 * Llama a un nuevo hilo para atender las solicitudes.
 * 
 * @param	port	puerto escucha del servidor.
 */
    public ChatServer(int port) throws IOException {
        Vector vector = new Vector();
        ServerSocket server = new ServerSocket(port);
        while(true) {
            Socket client = server.accept();
            BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
            String user = in.readLine();
            vector.add(user);
            ChatHandler handlerThread = new ChatHandler(client, user, vector);
            handlerThread.start();
        }
    }
    
/**
 * Mtodo main. Acepta los argumentos de entrada.
 * 
 * @param	args	Por defecto el puerto escucha es 12468.
*/    
    public static void main(String args[]) throws IOException {
        if (args.length == 0)
            new ChatServer(12468);
        else if (args.length == 1) {
            Integer port = new Integer(args[0]);
            new ChatServer(port.intValue());
        } else {
            System.out.println();
            System.out.println("USSAGE:  ChatServer <port_listen>");
            System.out.println("         ChatServer");
            System.out.println();
            System.out.println("         by default set port 12468");
            System.out.println();
        }
    }
}
